# (anssi) The unversioned symlink of XvMC library must be present in
# %{_libdir} during normal use, as libXvMC uses that name for dlopening.
# Our devel requires finder catches that, hence this exception:
%define _requires_exceptions devel(
%define _disable_ld_no_undefined 1

Name: x11-driver-video-intel
Version: 2.7.0
Release: %mkrel 1
Summary: X.org driver for Intel graphics controllers
Group: System/X11
URL: http://xorg.freedesktop.org
Source: http://xorg.freedesktop.org/releases/individual/driver/xf86-video-intel-%{version}.tar.bz2
License: MIT
BuildRoot: %{_tmppath}/%{name}-root

BuildRequires: libx11-devel >= 1.0.0
BuildRequires: libdrm-devel >= 2.4.6
BuildRequires: libxvmc-devel >= 1.0.1
BuildRequires: x11-proto-devel >= 1.0.0
BuildRequires: x11-server-devel >= 1.3
BuildRequires: x11-util-macros >= 1.0.1
BuildRequires: GL-devel

Conflicts: xorg-x11-server < 7.0
Obsoletes: x11-driver-video-intel13 <= 1.9.94

# (cg) Fix #38892. This is because we removed the obsoletion of the i810
# package due to a bug (#34583) which we can hopefully close post 2008.1
# if this -intel driver now works for that h/w
Conflicts: x11-driver-video-i810 < 1.7.4-23

# Mandriva patches
Patch1:  0001-Mandriva-fix-check-vt-switch.patch

# patches from Moblin to make X start faster on i830
Patch500: 0500-i830-002_avoid_duplicate_SaveHWState.patch
Patch501: 0501-i830-004_reduce_driver_boottime.patch
Patch502: 0502-i830-005_disable_sdvo_TV_port_restoreHW.patch
Patch503: 0503-i830-006_disable_check_lvds_panelpower_status.patch

%description
x11-driver-video-intel is the X.org driver for Intel video chipsets.

%package fast-i830
Summary: X.org driver for Intel graphics controllers optimized for i830
Group: System/X11

%description fast-i830
x11-driver-video-intel is the X.org driver for Intel video chipsets.

%prep
%setup -q -n xf86-video-intel-%{version}

# git-format-patch xf86-video-intel-2.5.0..patches-2.5.0 (where patches-2.5.0 is just
# a branch of xf86-video-intel-2.5.0 with mandriva patches)
%patch1 -p1

# Make sure duplicated code isn't compiled and only the server version is used
rm -fr src/modes

rm -rf fast-i830
cp -a . ../fast-i830
mv ../fast-i830 .
pushd fast-i830
%patch500 -p1
%patch501 -p1
%patch502 -p1
%patch503 -p1
popd

%build
autoreconf -ifs
%configure
%make
pushd fast-i830
autoreconf -ifs
%configure
%make
popd

%install
rm -rf %{buildroot}
%makeinstall_std
rm -f %{buildroot}%{_libdir}/xorg/modules/drivers/i810_drv.*
rm -f %{buildroot}%{_mandir}/man4/i810.4*

mkdir -p %{buildroot}%{_libdir}/xorg/modules/drivers/intel-common
mv %{buildroot}%{_libdir}/xorg/modules/drivers/intel_drv.* %{buildroot}%{_libdir}/xorg/modules/drivers/intel-common

mkdir -p %{buildroot}%{_libdir}/xorg/modules/drivers/intel-fast-i830
install fast-i830/src/.libs/intel_drv.so %{buildroot}%{_libdir}/xorg/modules/drivers/intel-fast-i830/
install fast-i830/src/.libs/intel_drv.lai %{buildroot}%{_libdir}/xorg/modules/drivers/intel-fast-i830/intel_drv.la

%clean
rm -rf %{buildroot}

# use posttrans so that files from old package are removed first
%posttrans
%{_sbindir}/update-alternatives \
  --install %{_libdir}/xorg/modules/drivers/intel_drv.so x11-intel-so %{_libdir}/xorg/modules/drivers/intel-common/intel_drv.so 20 \
  --slave   %{_libdir}/xorg/modules/drivers/intel_drv.la x11-intel-la %{_libdir}/xorg/modules/drivers/intel-common/intel_drv.la

%posttrans fast-i830
%{_sbindir}/update-alternatives \
  --install %{_libdir}/xorg/modules/drivers/intel_drv.so x11-intel-so %{_libdir}/xorg/modules/drivers/intel-fast-i830/intel_drv.so 10 \
  --slave   %{_libdir}/xorg/modules/drivers/intel_drv.la x11-intel-la %{_libdir}/xorg/modules/drivers/intel-fast-i830/intel_drv.la

%postun
[ $1 = 0 ] || exit 0
%{_sbindir}/update-alternatives --remove x11-intel-so %{_libdir}/xorg/modules/drivers/intel-common/intel_drv.so

%postun fast-i830
[ $1 = 0 ] || exit 0
%{_sbindir}/update-alternatives --remove x11-intel-so %{_libdir}/xorg/modules/drivers/intel-fast-i830/intel_drv.so

%files
%defattr(-,root,root)
%{_libdir}/libI810XvMC.la
%{_libdir}/libI810XvMC.so
%{_libdir}/libI810XvMC.so.1
%{_libdir}/libI810XvMC.so.1.0.0
%{_libdir}/libIntelXvMC.la
%{_libdir}/libIntelXvMC.so
%{_libdir}/libIntelXvMC.so.1
%{_libdir}/libIntelXvMC.so.1.0.0
%dir %{_libdir}/xorg/modules/drivers/intel-common
%{_libdir}/xorg/modules/drivers/intel-common/intel_drv.*
%{_libdir}/xorg/modules/drivers/ch7017.*
%{_libdir}/xorg/modules/drivers/ch7xxx.*
%{_libdir}/xorg/modules/drivers/ivch.*
%{_libdir}/xorg/modules/drivers/sil164.*
%{_libdir}/xorg/modules/drivers/tfp410.*
%{_mandir}/man4/intel.4*

%files fast-i830
%defattr(-,root,root)
%dir %{_libdir}/xorg/modules/drivers/intel-fast-i830
%{_libdir}/xorg/modules/drivers/intel-fast-i830/intel_drv.*


%changelog
* Thu Apr 16 2009 Colin Guthrie <cguthrie@mandriva.org> 2.7.0-1mdv2009.1
+ Revision: 367602
- New version: 2.7.0
- Drop tiling patch (included upstream)
- Require newer libdrm to build

* Thu Apr 09 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.6.99.903-0.20090409.1mdv2009.1
+ Revision: 365456
- Add fix for tiled rendering with gem disabled.

* Fri Apr 03 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.99.902-666.2.6.3.1mdv2009.1
+ Revision: 363713
- Revert to the 2.6.3 version for rc2

* Fri Mar 27 2009 Frederic Crozat <fcrozat@mandriva.com> 2.6.99.902-2mdv2009.1
+ Revision: 361658
- Revert to 2.6.99.902 tarball

* Thu Mar 26 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.99.902-1.20090324.3mdv2009.1
+ Revision: 361333
- Disable LVDS config parsing from VBT for now (mdv#49081, fdo#20752)

* Thu Mar 26 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.99.902-1.20090324.2mdv2009.1
+ Revision: 361284
- Add upstream patch to fix lvds config in vbt parsing.

* Tue Mar 24 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.99.902-1.20090324.1mdv2009.1
+ Revision: 360833
- Update to the latest 2.7 branch sources

* Sat Mar 21 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.99.902-1mdv2009.1
+ Revision: 359393
- Update to 2.7 branch release candidate: 2.6.99.902

* Mon Mar 02 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.6.3-1mdv2009.1
+ Revision: 347523
- New version 2.6.3

* Sat Feb 28 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.2-2mdv2009.1
+ Revision: 345948
- Upstream fix for memory overuse on 2D

* Wed Feb 25 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.2-1mdv2009.1
+ Revision: 344968
- New version: 2.6.2
- Drop upstream applied patches

* Wed Feb 18 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.6.1-5mdv2009.1
+ Revision: 342596
- Fix undefined symbol: i830_pad_drawable_width

* Tue Feb 17 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.6.1-4mdv2009.1
+ Revision: 342151
- Add patches from master to enable tiled rendering on pre-i965 hardware.

* Tue Jan 27 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.1-3mdv2009.1
+ Revision: 334084
- Bump release due to an attack from the ravenous package eating monster
- Fixup bogus VBT modes when detected (fdo#17292, mdv#45427)

* Thu Jan 22 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.6.1-1mdv2009.1
+ Revision: 332496
- New version: 2.6.1

* Thu Jan 15 2009 Colin Guthrie <cguthrie@mandriva.org> 2.6.0-1mdv2009.1
+ Revision: 329702
- New version: 2.6.0

* Sat Jan 10 2009 Colin Guthrie <cguthrie@mandriva.org> 2.5.99.2-1mdv2009.1
+ Revision: 327812
- Update/rediff the i830 patches (use git to make merging easier)
- New version: 2.5.99.2

* Tue Dec 30 2008 Colin Guthrie <cguthrie@mandriva.org> 2.5.99.1-1mdv2009.1
+ Revision: 321364
- New version 2.5.99.1

* Sat Nov 29 2008 Colin Guthrie <cguthrie@mandriva.org> 2.5.1-2mdv2009.1
+ Revision: 308025
- Rebuild against new xserver
- New version: 2.5.1

* Sun Nov 02 2008 Colin Guthrie <cguthrie@mandriva.org> 2.5.0-3mdv2009.1
+ Revision: 299261
- Rebuild for new libdrm

* Fri Oct 31 2008 Olivier Blin <oblin@mandriva.com> 2.5.0-2mdv2009.1
+ Revision: 298918
- rediff restoreHW disabling patch
- rediff boottime patch for 2.5.0
- add patches from Moblin to make X start faster on i830 (in a fast-i830 sub-package, to be enabled using alternatives)
- add alternatives for the intel driver (needed for fast-i830 and downscaling flavours)

* Wed Oct 22 2008 Colin Guthrie <cguthrie@mandriva.org> 2.5.0-1mdv2009.1
+ Revision: 296338
- New version: 2.5.0
- Drop upstream patches
- No longer revert the 'default to EXA' commits as EXA is apparently much better now

* Sat Oct 11 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.2-7mdv2009.1
+ Revision: 291869
- Add patch to disable render standby
- Cherry pick output detection for DVI patch and include missing hunks

* Fri Oct 03 2008 Pascal Terjan <pterjan@mandriva.org> 2.4.2-6mdv2009.0
+ Revision: 291023
- - Add upstream patch fixing HDMI output status detection

* Tue Sep 30 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.2-5mdv2009.0
+ Revision: 290277
- Add patch for PLL issue on 855GM (mdv#44398, fdo#17310)
- Add upstream patch from blank screens on xrandr calls on 845G (fdo#17756)

* Wed Sep 17 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.2-4mdv2009.0
+ Revision: 285366
- Cherry pick support for G41 chipset.

* Tue Sep 02 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.2-3mdv2009.0
+ Revision: 279122
- Solve the flicking problem when calling XRRGetScreenResources() (upstream)

* Wed Aug 27 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.2-2mdv2009.0
+ Revision: 276428
- Rebuild due to a hungry rpm-eating pixie that lives in the build-system
- New version: 2.4.2

* Tue Aug 19 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.1-1mdv2009.0
+ Revision: 274042
- New version
- Remove upstream patches applied upstream
- (Temporarily?) disabled PCPA's Sony VAIO fix while querying why it was not sent upstream

* Fri Aug 01 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.0-3mdv2009.0
+ Revision: 258839
- Fix the screen flicker in the upstream way.

* Wed Jul 30 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.0-2mdv2009.0
+ Revision: 254794
- Fix annoying flicker with LVDS on GTK apps by reverting upstream change.
- Rediff other patches

* Wed Jul 23 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.0-1mdv2009.0
+ Revision: 242418
- New version: 2.4.0

* Wed Jun 18 2008 Colin Guthrie <cguthrie@mandriva.org> 2.3.2-1mdv2009.0
+ Revision: 224987
- New version
- Define _disable_ld_no_undefined to make it build

  + Thierry Vignaud <tvignaud@mandriva.com>
    - improved description
    - add missing dot at end of description
    - improved summary

* Mon May 12 2008 Colin Guthrie <cguthrie@mandriva.org> 2.3.1-1mdv2009.0
+ Revision: 206118
- New version: 2.3.1
- Remove patches that are no longer used.

* Wed Apr 23 2008 Colin Guthrie <cguthrie@mandriva.org> 2.3.0-1mdv2009.0
+ Revision: 196751
- New version: 2.3.0

* Mon Apr 21 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.99.903-1mdv2009.0
+ Revision: 196343
- Latest 2.3 pre-release

* Wed Mar 26 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.1-5mdv2008.1
+ Revision: 190347
- Fix #38892 (conflict with older versions of -i810 driver)

* Tue Mar 25 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.1-4mdv2008.1
+ Revision: 189842
- Cherry pick another fix for 965GM to hopefully fix mdv#39018

* Fri Mar 21 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.1-3mdv2008.1
+ Revision: 189353
- Use git to properly revert the EXA by default commits (cleaner and more obvious)
- Add numerous quirks from upstream
- Backlight fixes for Fujitsu
- Mac Mini SDVO fixes
- Memory mangement fixes (hopefully address mdv#39018)

* Thu Mar 13 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.1-2mdv2008.1
+ Revision: 187702
- Revert to using XAA by default as it seems generally more reliable.

* Sat Feb 23 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.1-1mdv2008.1
+ Revision: 174075
- Official Release: 2.2.1

* Fri Feb 22 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.0.90-2mdv2008.1
+ Revision: 173799
- Rebase to upstream 2.2 driver branch.
- Remove G33 patch as it was reverted upstream.

* Sat Feb 09 2008 Colin Guthrie <cguthrie@mandriva.org> 2.2.0.90-1mdv2008.1
+ Revision: 164490
- Rebase on release 2.2.0.90

* Thu Feb 07 2008 Paulo Andrade <pcpa@mandriva.com.br> 2.2.0-7mdv2008.1
+ Revision: 163730
- Update to latest xf86-video-intel-2.2-branch.
  Patches are added from upstream tarball xf86-video-intel-2.2.0.tar.bz2

* Mon Jan 28 2008 Paulo Andrade <pcpa@mandriva.com.br> 2.2.0-6mdv2008.1
+ Revision: 159378
- Fix wrong package generation. Actually, tarball is still from tag
  xf86-video-intel-2.2.0, so generate patches from that point. Too bad
  patches did apply cleanly when generating them from
  xf86-video-intel-2.2-branch, but missed some bug fixes.
  Sorry for the inconvenince, I confused myself, but should not generate
  a tarball from xf86-video-intel-2.2-branch as there is no such upstream
  tarball.

* Mon Jan 28 2008 Paulo Andrade <pcpa@mandriva.com.br> 2.2.0-5mdv2008.1
+ Revision: 159337
- Rebase to origin/xf86-video-intel-2.2-branch.
  Remove mandriva+gpl branch and remake mandriva+custom patch to add
  Mandriva only old.

* Tue Jan 22 2008 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 2.2.0-4mdv2008.1
+ Revision: 156609
- re-enable rpm debug packages support

* Fri Jan 18 2008 Paulo Andrade <pcpa@mandriva.com.br> 2.2.0-3mdv2008.1
+ Revision: 154853
- Updated BuildRequires and resubmit package.
- Make sure symbols accessed using LoaderSymbol/dlsym are of public visibility.
  A different approach should be used so that compiler/dynamic loader could
  know what is going on, but for the moment making the symbols public is enough.
- Remove -devel package as it isn't really required as it provides only 2 files
  that aren't even header files; still don't install the .la files.
  All dependency files should be stored in the x11-util-modular package as they
  are only required for the "modular" build.
- Move .la files to new -devel package, and also add .deps files to -devel package.
- Update to properly generate tarball from existing tag xf86-video-intel-2.2.0.
  Patches since 2.2.0 to point where branch mandriva was created are Patch2
  and Patch3. So this should fix the other issue about updating cooker the
  modules.
- Update for new policy of hidden symbols and common macros.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Nov 18 2007 Colin Guthrie <cguthrie@mandriva.org> 2.2.0-1mdv2008.1
+ Revision: 109973
- New version

* Mon Nov 12 2007 Colin Guthrie <cguthrie@mandriva.org> 2.1.99-2mdv2008.1
+ Revision: 108137
- Drop (rather than just disable) upstream applied patches
- Add a patch to fix a typo in an upstream applied patch (hopefully fixes #35013)

* Fri Nov 09 2007 Colin Guthrie <cguthrie@mandriva.org> 2.1.99-1mdv2008.1
+ Revision: 107071
- New version (2.2 pre-release)
- (temporarily) disable some of the patches from Peter Clifton

* Wed Oct 24 2007 Colin Guthrie <cguthrie@mandriva.org> 2.1.1-6mdv2008.1
+ Revision: 101662
- Various minor fixes from Peter Clifton (Ubuntu)
- Remove legacy i810 links (in order to remove conflicts with the older driver needed on some older chipsets)

* Mon Oct 15 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 2.1.1-5mdv2008.1
+ Revision: 98696
- minor spec cleanup
- build against new xserver (1.4)

* Tue Sep 25 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.1.1-4mdv2008.0
+ Revision: 92861
- Fixed G33 support after adding G33 changes since kernel
  2.6.22.6-3mdv2008.0 (http://lkml.org/lkml/2007/9/20/71), reported by
  Damien Lallement.

  + Pixel <pixel@mandriva.com>
    - don't blindly choose biosmode over programmed mode (#33900)

* Fri Sep 21 2007 Pixel <pixel@mandriva.com> 2.1.1-2mdv2008.0
+ Revision: 91769
- fix choosing the correct bios mode on a laptop when the EDID is not available

* Tue Aug 14 2007 Colin Guthrie <cguthrie@mandriva.org> 2.1.1-1mdv2008.0
+ Revision: 62962
- New upstream version: 2.1.1

* Fri Aug 03 2007 Paulo Andrade <pcpa@mandriva.com.br> 2.1.0-2mdv2008.0
+ Revision: 58609
- Make sure duplicated code is not being used as it may cause unexpected behaviour

* Tue Jul 03 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 2.1.0-1mdv2008.0
+ Revision: 47565
- new upstream version: 2.1.0

* Fri Apr 27 2007 Anssi Hannula <anssi@mandriva.org> 2.0.0-2mdv2008.0
+ Revision: 18778
- fix -devel requires

* Fri Apr 20 2007 Colin Guthrie <cguthrie@mandriva.org> 2.0.0-1mdv2008.0
+ Revision: 15619
- New Release 2.0.0
- Obsolete latest x11-driver-video-intel13 package

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - This requires x11-server >= 1.2.99
    - Finish renaming from i810 to intel
    - New upstream release candidate: 1.9.94 (2.0 RC4)
    - Remove fix-version-test patch: not needed anymore
    - The Intel driver was renamed upstream from i810 to intel, as it supports
      not only i8xx chipsets but also i9xx


* Thu Mar 22 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.7.4-22mdv2007.1
+ Revision: 147969
- run autoreconf fixing some version mismatch problems of libtool
- This driver requires libdrm >= 2.2 (#29642)

* Tue Jan 09 2007 Thierry Vignaud <tvignaud@mandriva.com> 1.7.4-1mdv2007.1
+ Revision: 106688
- new release

* Fri Dec 08 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.7.3-1mdv2007.1
+ Revision: 93723
- bump release
  patch 1: fix build

* Wed Aug 23 2006 Antonio Hobmeir Neto <neto@mandriva.com> 1.6.5-2mdv2007.0
+ Revision: 57489
- Rename back to i810
- Returns to the name i810 because the tarball keep this name

* Tue Aug 22 2006 Antonio Hobmeir Neto <neto@mandriva.com> 1.6.5-1mdv2007.0
+ Revision: 57038
- new upstream release: 1.6.5
  Changes since 1.6.0:
    * Add an API for programming i915 fragment programs.
    * Convert i915 rotate code to the new fragment program API.
    * Adds MergedFB support
    * Fix configure.ac to check for xineramaproto
    * Adds i965 support
    * Many other bugfixes
- Package was renamed upstream. Following the name scheme.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix group
    - rebuild with the proper ABI on x86_64

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - added patch: prevents the driver from doing operations when we do not have the VT lock
    - rebuild to fix cooker uploading
    - Updated drivers for X11R7.1
    - increment release
    - Adding X.org 7.0 to the repository

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

